<?php

$messages = Array();

function debug_msg( $msg ) {
    global $messages;
    if( LMI_MODE == "1" ) {
        if( !defined( "_DEBUG_HEADER")  ) {
            echo "<h2>WebMoney Notify_wm.php Debug OUTPUT</h2>";
            define( "_DEBUG_HEADER", "1" );
        }
        $messages[] = "<pre>$msg</pre>";
        echo end( $messages );
    }
}
	
if ($_POST) {
	header("HTTP/1.0 200 OK");

    global $mosConfig_absolute_path, $mosConfig_live_site, $mosConfig_lang, $database,
    $mosConfig_mailfrom, $mosConfig_fromname;
    
        /*** access Joomla's configuration file ***/
        $my_path = dirname(__FILE__);
        
        if( file_exists($my_path."/../../../configuration.php")) {
            $absolute_path = dirname( $my_path."/../../../configuration.php" );
            require_once($my_path."/../../../configuration.php");
        }
        elseif( file_exists($my_path."/../../configuration.php")){
            $absolute_path = dirname( $my_path."/../../configuration.php" );
            require_once($my_path."/../../configuration.php");
        }
        elseif( file_exists($my_path."/configuration.php")){
            $absolute_path = dirname( $my_path."/configuration.php" );
            require_once( $my_path."/configuration.php" );
        }
        else {
            die( "Joomla Configuration File not found!" );
        }
        
        $absolute_path = realpath( $absolute_path );
        
        // Set up the appropriate CMS framework
        if( class_exists( 'jconfig' ) ) {
			define( '_JEXEC', 1 );
			define( 'JPATH_BASE', $absolute_path );
			define( 'DS', DIRECTORY_SEPARATOR );
			
			// Load the framework
			require_once ( JPATH_BASE . DS . 'includes' . DS . 'defines.php' );
			require_once ( JPATH_BASE . DS . 'includes' . DS . 'framework.php' );

			// create the mainframe object
			$mainframe = & JFactory::getApplication( 'site' );
			
			// Initialize the framework
			$mainframe->initialise();
			
			// load system plugin group
			JPluginHelper::importPlugin( 'system' );
			
			// trigger the onBeforeStart events
			$mainframe->triggerEvent( 'onBeforeStart' );
			$lang =& JFactory::getLanguage();
			$mosConfig_lang = $GLOBALS['mosConfig_lang']          = strtolower( $lang->getBackwardLang() );
			// Adjust the live site path
			$mosConfig_live_site = str_replace('/administrator/components/com_virtuemart', '', JURI::base());
			$mosConfig_absolute_path = JPATH_BASE;
			debug_msg( "0. Finished Initialization of the joomla1.5 config" );
        } else {
        	define('_VALID_MOS', '1');
        	require_once($mosConfig_absolute_path. '/includes/joomla.php');
        	require_once($mosConfig_absolute_path. '/includes/database.php');
        	$database = new database( $mosConfig_host, $mosConfig_user, $mosConfig_password, $mosConfig_db, $mosConfig_dbprefix );
        	$mainframe = new mosMainFrame($database, 'com_virtuemart', $mosConfig_absolute_path );
        }

        // load Joomla Language File
        if (file_exists( $mosConfig_absolute_path. '/language/'.$mosConfig_lang.'.php' )) {
            require_once( $mosConfig_absolute_path. '/language/'.$mosConfig_lang.'.php' );
        }
        elseif (file_exists( $mosConfig_absolute_path. '/language/english.php' )) {
            require_once( $mosConfig_absolute_path. '/language/english.php' );
        }
    /*** END of Joomla config ***/
    
    
    /*** VirtueMart part ***/
		global $database;        
        require_once($mosConfig_absolute_path.'/administrator/components/com_virtuemart/virtuemart.cfg.php');
        include_once( ADMINPATH.'/compat.joomla1.5.php' );
        require_once( ADMINPATH. 'global.php' );
        require_once( CLASSPATH. 'ps_main.php' );
		require_once( CLASSPATH. 'ps_database.php' );
		require_once( CLASSPATH. 'ps_order.php' );

        
        /* @MWM1: Logging enhancements (file logging & composite logger). */
        $vmLogIdentifier = "notify_wm.php";
        require_once(CLASSPATH."Log/LogInit.php");
              
        /* Load the PayPal Configuration File */ 
        require_once( CLASSPATH. 'payment/ps_webmoney.cfg.php' );
        
		if( LMI_MODE == "1" ) {
			$debug_email_address = $mosConfig_mailfrom;
		}
		else {
			//$debug_email_address = WEBMONEY_EMAIL;
			$debug_email_address = $mosConfig_mailfrom;
		}
	    // restart session
	    // Constructor initializes the session!
	    $sess = new ps_session();                        
	    
    /*** END VirtueMart part ***/

/*==================================== WENBONEY PART ============================================*/

/*=======================    Формы предварительного запроса   	================================ */

	//debug_msg( "0. Activating WebMoney testing LMI_MODE: $test" );
	//debug_msg( "1. Finished Initialization of the notify_wm.php script" );
	
	$post_msg = "";
	$pure_feedback 	= array();
	
	foreach ($_POST as $ipnkey => $ipnval) {
        $post_msg .= "$ipnkey=$ipnval&amp;";
    }
	
	$post_msg = "";
	
	/*if( LMI_MODE == "1" ){
   	 debug_msg( "2. Received POST" );
	}*/
    
	foreach ($_POST as $ipnkey => $ipnval) {
		// Fix issue with magic quotes
		if (get_magic_quotes_gpc())	{
			$ipnkey = stripslashes ($ipnkey);
			$ipnval = stripslashes ($ipnval);
		}
		// ^ Antidote to potential variable injection and poisoning    
        if (!eregi("^[_0-9a-z-]{1,30}$",$ipnkey))  { 
            unset ($ipnkey); 
            unset ($ipnval); 
        } 
		$pure_feedback[$ipnkey] = $ipnval;
    } 
 
	// prerequest

$wm_post_0	= trim($_POST['LMI_PREREQUEST']);		//	Флаг предварительного запроса.
//$wm_post_1	= trim($_POST['LMI_PAYEE_PURSE']);		//	Кошелек продавца, на который покупатель совершил платеж. Формат - буква и 12 цифр.
//$wm_post_2	= trim($_POST['LMI_PAYMENT_AMOUNT']);	//	Сумма, которую заплатил покупатель. Дробная часть отделяется точкой.
//$wm_post_3	= trim($_POST['LMI_PAYMENT_NO']);		//	В этом поле передается номер покупки в соответствии с системой учета продавца, полученный сервисом с веб-сайта продавца.
$wm_post_4	= trim($_POST['LMI_MODE']);				//	Указывает, в каком режиме выполнялась обработка запроса на платеж.
$wm_post_5	= trim($_POST['LMI_PAYER_PURSE']);		//	Кошелек, с которого покупатель совершил платеж.
$wm_post_6 	= trim($_POST['LMI_PAYER_WM']);			//	WM-идентификатор покупателя, совершившего платеж. */
	//transaction
$wm_post_7	= trim($_POST['LMI_SYS_INVS_NO']);		//	Номер счета в системе WebMoney Transfer, выставленный покупателю от имени продавца в процессе обработки запроса на выполнение платежа сервисом WebMerchantInterface. 
$wm_post_8	= trim($_POST['LMI_SYS_TRANS_NO']);		// 	Номер платежа в системе WebMoney Transfer, выполненный в процессе обработки запроса на выполнение платежа сервисом Web Merchant Interface. 
$wm_post_9	= trim($_POST['LMI_SYS_TRANS_DATE']);	//	Дата и время реального прохождения платежа в системе WebMoney Transfer в формате "YYYYMMDD HH:MM:SS".
$wm_post_10 = trim($_POST['LMI_HASH']);				//	Контрольная подпись оповещения о выполнении платежа, которая используется для проверки целостности полученной информации и однозначной идентификации отправителя.

	

	foreach ($pure_feedback as $wm_name => $wm_value){
		if($wm_name == LMI_PAYMENT_NO){
			$invoice = $wm_value;
		}
		if($wm_name == LMI_PAYMENT_AMOUNT){
			$final_cost = $wm_value;
		}
		if($wm_name == LMI_PREREQUEST){
			$prerequest_mode = $wm_value;
		}
	}
	
	
	$account_number_stored = LMI_PAYEE_PURSE; 
	$secret_key	= WEBMONEY_SECRET_CODE;

if ($prerequest_mode == "1")
{	
	
	$account_number_stored 		= LMI_PAYEE_PURSE;
	$account = trim($_POST['LMI_PAYEE_PURSE']);
	
	if($account != $account_number_stored ) { 
    $err=1;
    echo "ERR: НЕВЕРНЫЙ КОШЕЛЕК ПОЛУЧАТЕЛЯ ".$_POST['LMI_PAYEE_PURSE'];
    exit;
	}
	
	//retrieving invoice parameters from DB
	
    $qv = "SELECT `order_id`, `order_number`, `user_id`, `order_subtotal`,
                    `order_total`, `order_currency`, `order_tax`, 
                    `order_shipping_tax`, `coupon_discount`, `order_discount`, `ip_address`
                FROM `#__{vm}_orders` 
                WHERE `order_id`='".$invoice."'";
	$db_wm = new ps_DB;
	$query = $db_wm->query($qv);		
    $db_wm->query($qv);
    $db_wm->next_record();
	if( $db_wm->f( 'order_id' ) ) {
		$order_id = $db_wm->f( 'order_id' );
		if(!$order_id or $order_id=="") {
			$err=1;
			echo "ERR: НЕТ ТАКОГО ТОВАРА";
			exit;
		}
	}
	  
	if( $db_wm->f( 'order_total' ) ) {
		$order_total_cost = $db_wm->f( 'order_total' );
		if(!$order_total_cost or $order_total_cost=="") {
			$err=1;
			echo "ERR: НЕТ ТАКОЙ ЦЕНЫ";
			exit;
		}
		if ($order_total_cost != $final_cost){
			$err=1;
			$shop_user = $db_wm->f( 'user_id' );
			$user_ip = $db_wm->f( 'ip_address' );
			echo "ERR: НЕВЕРНАЯ СУММА ".$final_cost;
				
				//notify shop owner about possible fraud
           		$mailsubject = "Попытка взлома магазина ";
				$mailbody = "ЗАФИКСИРОВАНА ПОПЫТКА ИЗМЕНЕНИЯ СТОИМОСТИ ОПЛАТЫ \n\n";
            	$mailbody .= "Заказ номер : ".$order_id." \n";
				$mailbody .= "Номер покупателя в магазине : ".$shop_user." \n";
				$mailbody .= "IP address : ".$user_ip." \n";
				$mailbody .= "Настоящая цена : ".$order_total_cost." \n";
				$mailbody .= "Измененная цена : ".$final_cost." \n";
				vmMail( $mosConfig_mailfrom, $mosConfig_fromname, $debug_email_address, $mailsubject, $mailbody ); 
	
			exit;
		}
	  }
	if(!$err){
		echo "YES";
	}
}
/*==============================================  Форма оповещения о платеже  ===========================================*/
else 
{
		$qv = "SELECT `order_id`, `order_number`, `user_id`, `order_subtotal`,
						`order_total`, `order_currency`, `order_tax`, 
						`order_shipping_tax`, `coupon_discount`, `order_discount`, `ip_address`
					FROM `#__{vm}_orders` 
					WHERE `order_id`='".$invoice."'";
		$db_wm = new ps_DB;
		$query = $db_wm->query($qv);		
		$db_wm->query($qv);
		$db_wm->next_record();
		$order_total_cost = $db_wm->f( 'order_total' );
		$shop_user = $db_wm->f( 'user_id' );
		$user_ip = $db_wm->f( 'ip_address' );
		$order_id = $db_wm->f( 'order_id' );

		$common_string = $_POST['LMI_PAYEE_PURSE'].$_POST['LMI_PAYMENT_AMOUNT'].$_POST['LMI_PAYMENT_NO'].$_POST['LMI_MODE'].$_POST['LMI_SYS_INVS_NO'].$_POST['LMI_SYS_TRANS_NO'].$_POST['LMI_SYS_TRANS_DATE'].$secret_key.$_POST['LMI_PAYER_PURSE'].$_POST['LMI_PAYER_WM'];
		 
		$hash = strtoupper(md5($common_string));
		if($hash!=$wm_post_10) {
			$mailsubject = "Попытка взлома магазина ";
			$mailbody  = "Зафиксирована попытка изменения параметров оплаты\n\n";
			$mailbody .= "Подменили зашифрованный ключ HASH MD5\n";
			$mailbody .= "Заказ номер : ".$order_id." \n";
			$mailbody .= "Номер покупателя в магазине : ".$shop_user." \n";
			$mailbody .= "IP address : ".$user_ip." \n";
			$mailbody .= "Настоящая цена : ".$order_total_cost." \n";
			$mailbody .= "Измененная цена : ".$final_cost." \n";
			$mailbody .= "Полученный HASH : ".$wm_post_10." \n";
			$mailbody .= "Настоящий HASH  : ".$hash." \n";
			//$mailbody .= "секрет  : ".$secret_key." \n";
			vmMail( $mosConfig_mailfrom, $mosConfig_fromname, $debug_email_address, $mailsubject, $mailbody ); 
			debug_msg( "1. HASH changed" );
			exit;
		}
		else {
			$d['order_id'] = $order_id;
			$d['notify_customer'] = "Y";
			$d['order_total'] = $order_total_cost;
			$d['order_status'] = WEBMONEY_VERIFIED_STATUS;                    
			$ps_order= new ps_order;
			$ps_order->order_status_update($d);
			
			$d['order_status'] = "Подтвержденный";
				
			$dbbt1 = new ps_DB;
			$q  = "SELECT * FROM #__{vm}_order_user_info WHERE order_id='" . $order_id . "' ORDER BY address_type ASC"; 
			$dbbt1->query($q);
			$dbbt1->next_record(); 
			$recipient = $dbbt1->f("user_email");
				
			$mailsubject = "Ваш заказ № ".$d['order_id']." оплачен.";
				
			$mailbody = "Ваш заказ № ".$d['order_id']." оплачен. \n\n";
			$mailbody .= "--------------------------------------- \n";
			$mailbody .= "Информация о заказе \n";
			$mailbody .= "Заказ №: ".$d['order_id']." \n";
			$mailbody .= "Статус заказа: ".$d['order_status']." \n";
			$mailbody .= "Цена: ".$d['order_total']." евро. \n";
			$mailbody .= "--------------------------------------- \n";
			$mailbody .= "Информация о заказчике \n\n";
			$mailbody .= "Компания: ".$dbbt1->f("company")." \n";
			$mailbody .= "Фамилия: ".$dbbt1->f("last_name")." \n";
			$mailbody .= "Имя: ".$dbbt1->f("first_name")." \n";
			$mailbody .= "Отчество: ".$dbbt1->f("middle_name")." \n";
			$mailbody .= "Страна: ".$dbbt1->f("country")." \n";
			$mailbody .= "Город: ".$dbbt1->f("city")." \n";
			$mailbody .= "Адрес: ".$dbbt1->f("address_1")." \n";
			$mailbody .= "Телефон: ".$dbbt1->f("phone_1")." \n";
			$mailbody .= "E-Mail: ".$dbbt1->f("user_email")." \n";
			$mailbody .= "--------------------------------------- \n";
			$mailbody .= "Информация об оплате \n\n";
			$mailbody .= "Сумма платежа: ".$d['order_total']." евро. \n";
			$mailbody .= "Номер счета: ".$wm_post_7." \n";
			$mailbody .= "Номер платежа: ".$wm_post_8." \n";
			$mailbody .= "Дата и время платежа: ".$wm_post_9."\n";
				
			vmMail( $mosConfig_mailfrom, $mosConfig_fromname, $recipient, $mailsubject, $mailbody );
			vmMail( $mosConfig_mailfrom, $mosConfig_fromname, $debug_email_address, $mailsubject, $mailbody ); 
			//vmRedirect( "index.php?option=com_virtuemart&page=account.order_details&order_id=".$d['order_id']."&Itemid=4" ); 
		}
		
}
}
?>
